;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Form List Editor double click patch
;File version 0.1.2 (ported from GECK-PU-FO3 version 0.1.1.0)
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 7 July 2011)

PATCH_FORMLISTDBLCLK_OFFSET = 005AE0A7h ;       005ADF77h ;       005ACC47h
PATCH_FORMLISTDBLCLK_LENGTH = 6d
PATCH_FORMLISTDBLCLK_RETURN = 005AE12Eh ;       005ADFFEh ;       005ACCCEh


macro FORMLISTEDITOR_DBLCLK_DATA {
	AddrOf_Callback_FormList_DblClk dd ?
}

macro FORMLISTEDITOR_DBLCLK_PATCHES {
	stdcall MakeMemWriteable, PATCH_FORMLISTDBLCLK_OFFSET, PATCH_FORMLISTDBLCLK_LENGTH
	mov [AddrOf_Callback_FormList_DblClk], Callback_FormList_DblClk
	;mov ecx, dword ptr ds:[0ece730] -> mov ecx, dword ptr ds:[AddrOf_Callback_FormList_DblClk]
	mov [PATCH_FORMLISTDBLCLK_OFFSET], DWORD AddrOf_Callback_FormList_DblClk
	;mov edx, dword ptr ds:[eax] -> call ecx
	mov [PATCH_FORMLISTDBLCLK_OFFSET+4], WORD 0D1FFh
	call RestoreMemProtection
}

macro FORMLISTEDITOR_DBLCLK_CALLBACKS {
	Callback_FormList_DblClk:
	test eax, eax
	jnz .run_normally
	
	;This is how we quit if nothing was selected
	add esp, 4
	mov [esp], DWORD PATCH_FORMLISTDBLCLK_RETURN
	ret
	
	.run_normally:
	mov ecx, DWORD [00ECFB38h]	;       [00ECFAB8h]      ;       [00ECE730h]      ;Copied from original
	mov edx, DWORD [eax]	;Copied from original
	mov [esp], DWORD PATCH_FORMLISTDBLCLK_OFFSET + PATCH_FORMLISTDBLCLK_LENGTH
	ret
}