;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Patch to bypass compilation when saving scripts
;File version 0.1.2 (ported from GECK-PU-FO3 0.1.1.0)
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 7 July 2011)

PATCH_SCRIPTEDITOR_COMPILER_OFFSET = 005C31B8h	;       005C3028h  ;       005C2BE8h
PATCH_SCRIPTEDITOR_COMPILER_LENGTH = 8
PATCH_SCRIPTEDITOR_COMPILER_ORIG = 005C9800h	;       005C9670h  ;       005C9230h


macro SCRIPTS_COMPILATION_BYPASS_DATA {
	SaveWithoutCompilationName db "Save w/o compiling and close", 0
	EndOf_SaveWithoutCompilationName:
	SaveNoCompileConfirmation db "Really save without compilation? Don't forget about the ScriptName issue.", 0
	bBypassCompilation db 0 ;Usage of this global might cause issues, but we don't have a good local thread storage yet
}

macro SCRIPTS_COMPILATION_BYPASS_PATCHES {
	;Hijacking the call to script compiler
	stdcall MakeMemWriteable, PATCH_SCRIPTEDITOR_COMPILER_OFFSET, PATCH_SCRIPTEDITOR_COMPILER_LENGTH
	;push 0; push esi; call PATCH_SCRIPTEDITOR_COMPILER_ORIG -> mov eax, <Callback_CallCompiler>; call eax; nop
	mov [PATCH_SCRIPTEDITOR_COMPILER_OFFSET], BYTE 0B8h
	mov [PATCH_SCRIPTEDITOR_COMPILER_OFFSET+1], DWORD Callback_CallCompiler
	mov [PATCH_SCRIPTEDITOR_COMPILER_OFFSET+5], WORD 0D0FFh
	mov [PATCH_SCRIPTEDITOR_COMPILER_OFFSET+7], BYTE 90h
	call RestoreMemProtection
}

macro SCRIPTS_COMPILATION_BYPASS_CALLBACKS {
	Callback_CallCompiler:
	cmp [bBypassCompilation], 0
	jne .run_with_bypass
	
	push 0
	push esi
	mov eax, PATCH_SCRIPTEDITOR_COMPILER_ORIG
	call eax
	retn
		
	.run_with_bypass:
	mov [bBypassCompilation], 0
	mov eax, 1
	retn
}

;eax contains menu handle
macro SCRIPTS_COMPILATION_BYPASS_SCRIPTEDITORMENU {
	SCRIPTS_COMPILATION_BYPASS_SCRIPTEDITORMENU:	;For local labels to be appended to
	mov [esp+MII_fMask], DWORD MIIM_FTYPE + MIIM_ID + MIIM_STRING
	mov [esp+MII_fType], DWORD MFT_STRING
	mov [esp+MII_wID], DWORD MENU_SCRIPTEDITOR_SAVENOCOMPILE
	mov [esp+MII_dwTypeData], DWORD SaveWithoutCompilationName
	mov [esp+MII_cch], DWORD EndOf_SaveWithoutCompilationName - SaveWithoutCompilationName
	push eax
	push ecx
	mov ecx, esp
	add ecx, 8
	invoke InsertMenuItem, eax, MENU_SCRIPTEDITOR_OLD_DELETE, FALSE, ecx
	test eax, eax
	jnz .second_phase
	call PatchAbort
	
	.second_phase:
	mov eax, [esp+4]
	mov ecx, esp
	add ecx, 8
	mov [esp+8+MII_fMask], DWORD MIIM_FTYPE
	mov [esp+8+MII_fType], DWORD MFT_SEPARATOR
	invoke InsertMenuItem, eax, MENU_SCRIPTEDITOR_OLD_DELETE, FALSE, ecx
	test eax, eax
	jnz .return
	call PatchAbort
	
	.return:
	pop ecx
	pop eax
}

macro SCRIPTS_COMPILATION_BYPASS_MENUCOMMAND_SAVENOCOMPILE {
	SCRIPTS_COMPILATION_BYPASS_MENUCOMMAND_SAVENOCOMPILE:
	mov eax, [esp+4]
	invoke MessageBoxEx, eax, SaveNoCompileConfirmation, GECKPowerUp, MB_OKCANCEL, LANG
	cmp eax, IDOK
	je .do_savenocompile
	
	mov eax, 1
	retn 16
	
	.do_savenocompile:
	mov [esp+12], DWORD MENU_SCRIPTEDITOR_OLD_SAVE
	mov [bBypassCompilation], 1
	mov eax, esp
	invoke PostMessage, [eax+4], WM_CLOSE, 0, 0
}